; ----------------------------------------------------------------------------
;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x / NT
; Author:         Insolence <insolence_9@yahoo.com>
;
; Script Function:
;	GUI for iPFU
;
; ----------------------------------------------------------------------------
Opt("GUIOnEventMode", 1)
Opt("RunErrorsFatal", 0)

   ; ----------------------------------------------------------------------------
   ; Includes // Variables
   ; ----------------------------------------------------------------------------
#include <include/GUIConstants.au3>
#include <include/Array.au3>
#include <include/iPFU_Funcs.au3>

$iPFUIni = @ScriptDir & "\config.ini"

   ; ----------------------------------------------------------------------------
   ; Telling the GUI to update the Module list
   ; ----------------------------------------------------------------------------
IniWrite ( @ScriptDir & "\modules.ini", "Modules", "updated", 1)

   ; ----------------------------------------------------------------------------
   ; Creating GUI
   ; ----------------------------------------------------------------------------
$GUI = GuiCreate("iPFU Interface", 450, 200, 0, 0, $WS_OVERLAPPEDWINDOW + $WS_VISIBLE)
GuiSetOnEvent($GUI_EVENT_CLOSE, "Close")

GUISetFont (8, 400, -1, "Verdana")

   ; ----------------------------------------------------------------------------
   ; Creating menu's
   ; ----------------------------------------------------------------------------
$helpmenu = GUICtrlCreateMenu ("Help")
$aboutitem = GUICtrlCreateMenuitem ("About",$helpmenu)
GUICtrlSetOnEvent(-1, "_DisplayLicense")

   ; ----------------------------------------------------------------------------
   ; Tabs
   ; ----------------------------------------------------------------------------
$tab = GUICtrlCreateTab ( -1, 0, 455, 200 )

DIM $TabItem[2]

_ArrayAdd($TabItem, GUICtrlCreateTabitem ("Modules"))
   GUICtrlCreateLabel ("Module(s):", 5, 25)
   $ModuleList = GUICtrlCreateList ( "", 5, 38, 200, 120 )
   GUICtrlSetOnEvent(-1, "_DisplayDescription")
   GUICtrlSetLimit(-1,200)
   
   GUICtrlCreateGroup ("Description", 208, 25, 240, 155)
   
   $LoadModule = GUICtrlCreateButton ("Load", 5, 150, 75)
   GUICtrlSetOnEvent(-1, "_LoadModule")
   $UnloadModule = GUICtrlCreateButton ("Unload", 80, 150)
   GUICtrlSetOnEvent(-1, "_UnloadModule")
   $AddModule = GUICtrlCreateButton ("Add", 127, 150, 75)
   GUICtrlSetOnEvent(-1, "_GetModulePath")
   
_ArrayAdd($TabItem, GUICtrlCreateTabitem ("Configuration"))   
   GUICtrlCreateLabel ("Username", 5, 25)
   $Username = GUICtrlCreateInput ( "", 70, 23, 150, 17)
   GUICtrlSetData(-1,_ReadConfig( $iPFUIni, "Username"))
   
   GUICtrlCreateLabel ("Password", 5, 46)
   $Password = GUICtrlCreateInput ( "", 70, 44, 150, 17, $ES_PASSWORD)
   GUICtrlSetData(-1,_ReadConfig( $iPFUIni, "Password"))
   
   GUICtrlCreateLabel ("Character", 5, 75)
   $Position = GUICtrlCreateCombo ( "1", 70, 73, 35, 17)
   GUICtrlSetData(-1,"2|3|4|5|6|7|8", _ReadConfig( $iPFUIni, "Character", "1"))
   
   GUICtrlCreateLabel ("Realm", 5, 96)
   $Realm = GUICtrlCreateCombo  ( "USWest", 70, 94, 75, 17)
   GUICtrlSetData(-1,"USEast|Europe", _ReadConfig( $iPFUIni, "Realm", "USEast"))
   
   GUICtrlCreateLabel ("Diablo.exe Path", 5, 130)
   $Path = GUICtrlCreateInput ( "", 100, 128, 250, 17)
   GUICtrlSetData(-1, _ReadConfig( $iPFUIni, "Path", "C:\Program Files\Diablo II\Diablo II.exe"))
   $GetPath = GUICtrlCreateButton ("Browse...", 355, 128, 60, 17)
   GUICtrlSetOnEvent(-1, "_GetD2Path")
   
   GUICtrlCreateGroup ("Delays", 230, 20, 200, 90)
   GUICtrlCreateLabel ("Send Key", 235, 40)
   $SendKey = GUICtrlCreateInput ( "", 312, 38, 25, 17)
   GUICtrlSetData(-1, _ReadConfig( $iPFUIni, "Send Key", "5"))
   GUICtrlCreateLabel ("Mouse Click", 235, 61)
   $MouseClick = GUICtrlCreateInput ( "", 312, 59, 25, 17)
   GUICtrlSetData(-1, _ReadConfig( $iPFUIni, "Mouse Click", "10"))
   GUICtrlCreateLabel ("Mouse Down", 235, 82)
   $MouseDown = GUICtrlCreateInput ("", 312, 80, 25, 17)
   GUICtrlSetData(-1, _ReadConfig( $iPFUIni, "Mouse Down", "10"))
   
   $SaveConfig = GUICtrlCreateButton ("Save Config", 5, 150)
   GUICtrlSetOnEvent(-1, "_SaveDefault")
   
;_ArrayAdd($TabItem, GUICtrlCreateTabitem ("Statistics"))
   ;$Statistics = GUICtrlCreateEdit ( "", 5, 25, 440, 155 )

   ; ----------------------------------------------------------------------------
   ; Show GUI, Close GUI, request user to configure if they haven't
   ; ----------------------------------------------------------------------------
GuiSetState(@SW_SHOW)

If _ReadConfig( $iPFUIni, "Been configured") = "" Then
   _MsgBox( 4, "iPFU", "As this is the first time running the program, please configure it under the 'Configuration' tab.")
EndIf

While 1
   $Modules_Check = IniRead( @ScriptDir & "\modules.ini", "Modules", "updated", 1)

   If $Modules_Check = 1 Then
      $Modules = _IniSplit( @ScriptDir & "\modules.ini", "modules", "installed", "", "," )
      For $i = 1 to $Modules[0]
         GUICtrlSetData($ModuleList,$Modules[$i])
      Next
      
      IniWrite ( @ScriptDir & "\modules.ini", "Modules", "updated", 0)
   EndIf

   Sleep(100)   
WEnd

   ; ----------------------------------------------------------------------------
   ; Functions
   ; ----------------------------------------------------------------------------
Func _GetD2Path()
   GUICtrlSetData ( $Path_Input, FileOpenDialog( "Please select Diablo II.exe", "C:\Program Files\Diablo II\", "Diablo II (Diablo II.exe)", 1 ) ) 
EndFunc

Func Close()
   Exit
EndFunc

Func _SaveDefault()
   IniWrite( @ScriptDir & "\config.ini", "config", "Username", GUICtrlRead ( $Username ) ) 
   IniWrite( @ScriptDir & "\config.ini", "config", "Password", GUICtrlRead ( $Password ) ) 
   IniWrite( @ScriptDir & "\config.ini", "config", "Position", GUICtrlRead ( $Position ) )
   IniWrite( @ScriptDir & "\config.ini", "config", "Realm", GUICtrlRead ( $Realm ) )
   IniWrite( @ScriptDir & "\config.ini", "config", "Path", GUICtrlRead ( $Path ) ) 
   IniWrite( @ScriptDir & "\config.ini", "config", "Send Key", GUICtrlRead ( $SendKey ) )
   IniWrite( @ScriptDir & "\config.ini", "config", "Mouse Click", GUICtrlRead ( $MouseClick ) )
   IniWrite( @ScriptDir & "\config.ini", "config", "Mouse Down", GUICtrlRead ( $MouseDown ) )
   IniWrite( @ScriptDir & "\config.ini", "config", "Been configured", 1 ) 

   _MsgBox(4,"iPFU success!", "Successfully configured.")
EndFunc


Func _GetModulePath()
   $File = FileOpenDialog( "Please select a Module", @ScriptDir & "\modules", "Module Settings (*.ini)", 1 ) 
   
   If Not @error Then
      $Name = IniRead( $File, "Description", "Name", "")

      If $Name <> "" Then
         $Modules = IniRead ( @ScriptDir & "\modules.ini", "Modules", "installed", "" )
         
         If $Modules <> "" Then
            $Name = "," & $Name
         EndIf
         
         $Modules = $Modules & $Name

         IniWrite ( @ScriptDir & "\modules.ini", "Modules", "installed", $Modules)
         IniWrite ( @ScriptDir & "\modules.ini", "Modules", "updated", 1)
         IniWrite ( $File, "iPFU", "location", @ScriptDir)
      Else
         _MsgBox(3, "iPFU File Error", "File does not seem to have been properly configured.")
      EndIf
   EndIf
EndFunc

Func _LoadModule()
   $Module = GUICtrlRead ( $ModuleList )
   
   RunWait ( @ScriptDir & "\modules\" & $Module & "\" & $Module & ".exe" )
   
   If @error  Then
      _MsgBox(3, "iPFU Error!", "Unable to locate module.")
   EndIf
EndFunc

Func _UnloadModule()
   $Module = GUICtrlRead ( $ModuleList )
   
   ProcessClose ( $Module & ".exe" )
EndFunc

Func _DisplayDescription()   
   $Module = GUICtrlRead ( $ModuleList )
   $Description = IniRead ( @ScriptDir & "\modules\" & $Module & "\" & $Module & ".ini", "Description", "Description", "" )
   GUICtrlCreateLabel ( $Description, 212, 40, 230, 130)
EndFunc

Func _DisplayLicense()
   _MsgBox(1, "iPFU", "    iPFU (C) 2004 Eric Carmichael <insolence_9@yahoo.com>"_ 
   & @LF & @LF & "    iPFU comes with ABSOLUTELY NO WARRANTY;"_
   & @LF & "    for further details and information on what"_
   & @LF & "    conditions you may distribute this program"_  
   & @LF & "    visit:"_    
	& @LF & @LF & "    http://www.gnu.org/")
EndFunc



   ; NOT USED
   ;===============================================================================
Func _LoadSettings()   
   Dim $Label[10]
   Dim $Input[10]
   
   $Last_Module = $Module
   
   $Module = GUICtrlRead ( $ModuleList )
   
   If $Last_Module <> $Module Then
      For $i = 1 to 10
         GUICtrlSetState($Label[$i],$GUI_HIDE) 
         GUICtrlSetState($Input[$i],$GUI_HIDE) 
      Next
   EndIf
   
   $Setting = _IniSplit( @ScriptDir & "\modules\" & $Module & "\settings.ini", "settings", "settings", "", "," )
 
   If $Setting <> "" Then
      For $i = 1 to $Setting[0]
         $LabelY = $i*20+19
         $InputY = $i*19+19
         
         $Label[$i] = GUICtrlCreateLabel ( $Setting[$i], 212, $LabelY, 81, 18)
         $Input[$i] = GUICtrlCreateInput ( "", 293, $InputY, 150, 17)
      Next
   EndIf
EndFunc